;scoff - supercart off
;aycock, 9/87
;
;
 *=$5555 ;out of the way
;
;
dosvec   = $A
rtclok   = $14
ramtop   = $6A
statsav  = $100
iccom    = $342
icbal    = $344
icbah    = $345
icax1    = $34A
basicf   = $3F8
cintlk   = $3FA
crtstat  = $AFFF
portb    = $D301
ossoff   = $D508
ciov     = $E456
;
;
 .byte $60   ;RTS for no re-entry
;
;
edev .byte "E:",$9B  ;in a safe place
;
;
;
START          ;THE ENTRY POINT...
;
 ldx #0        ;close E:
 lda #12
 sta iccom
 jsr ciov
;
 lda rtclok    ;wait for clock
CHK            ; to change
 cmp rtclok
 beq CHK
;
 sei           ;disable interrupts and
 lda crtstat   ; the supercart
 sta statsav
 sta ossoff
 lda #0
 sta cintlk
;
 lda #1        ;disable builtin basic
 sta basicf
 lda portb
 ora #2
 sta portb
;
 lda #$C0      ;reset ramtop
 sta ramtop
;
 cli           ;enable interrupts and
 ldx #0        ; reopen E:
 lda #3
 sta iccom
 lda #edev & $FF
 sta icbal
 lda #edev / $100
 sta icbah
 lda #12
 sta icax1
 jsr ciov
;
 jmp (dosvec)  ; back to Dos!
;
; INIT VECTOR
;
 *=$2E2
;
 .word START
